using System;
using System.Collections.Generic;
using System.Text;

namespace BmxCs {
	public class Bmx {
		BmxHeader header;
		public BmxHeader Header {
			get { return header; }
		}

		BmxScore score;
		public BmxScore Score {
			get { return score; }
		}

		string filename;
		public string FileName {
			get { return filename; }
		}

		List<int> pattern;
		public List<int> Pattern {
			get { return pattern; }
		}

		public Bmx(string filename) {
			this.filename = filename;
			header = new BmxHeader();
			score = new BmxScore();
			pattern = new List<int>();
		}

		public BmxTimingTable CreateTimingTable() {
			return new BmxTimingTable(this);
		}

	}

	public static class Base36 {
		public static int ToInt(string b36, int length) {
			int result = 0;

			if (b36.Length < length)
				length = b36.Length;

			for (int i = 0; i < b36.Length && i < length; i++) {
				char c = b36[i];
				if ('0' <= c && c <= '9')
					result = result * 36 + c - '0';
				else if ('a' <= c && c <= 'z')
					result = result * 36 + c - 'a' + 10;
				else if ('A' <= c && c <= 'Z')
					result = result * 36 + c - 'A' + 10;
				else
					throw new ArgumentException(string.Format("sȕ܂܂Ă܂ : {0} '{1}'", i, c), "b36");
			}

			return result;
		}

		public static int ToInt(string b36) {
			return ToInt(b36, 2);
		}

		public static string ToBase36(int i) {
			StringBuilder sb = new StringBuilder();
			ToBase36(sb, i);

			if (sb.Length == 1)
				sb.Insert(0, '0');

			return sb.ToString();
		}

		private static void ToBase36(StringBuilder sb, int i) {
			if (i == 0) return;

			int div, rem;
			div = Math.DivRem(i, 36, out rem);

			char c;
			
			unchecked {
				if (rem < 10)
					c = (char)('0' + rem);
				else
					c = (char)('A' + rem - 10);
			}
			
			ToBase36(sb, div);
			sb.Append(c);
		}
	}
}
