using System;
using System.Collections.Generic;
using System.Text;

namespace BmxCs {

	public class Event<T> : IComparable<Event<T>>, IComparer<Event<T>> {
		double time;
		double pos;
		T data;


		#region IComparable<Event<T>> o

		public int CompareTo(Event<T> other) {
			return this.time.CompareTo(other.time);
		}

		#endregion

		#region IComparer<Event<T>> o

		public int Compare(Event<T> x, Event<T> y) {
			return x.time.CompareTo(y.time);
		}

		#endregion

		/// <summary>
		/// VCxg̃CX^X쐬B
		/// </summary>
		/// <param name="time">̃Cxg̔^C~O(b)</param>
		/// <param name="pos">̃Cxg̊ył̈ʒu(ߒP)</param>
		/// <param name="data">Cxge\</param>
		public Event(double time, double pos, T data) {
			this.data = data;
			this.pos = pos;
			this.time = time;
		}

		public double Time {
			get { return time; }
			set { time = value; }
		}

		public T Data {
			get { return data; }
		}

		public double Position {
			get { return pos; }
		}

		public override string ToString() {
			return string.Format("{0} [{1}] : {2}", time, pos, data);
		}
	}
	/// <summary>
	/// 
	/// </summary>
	public class NoteEvent {
		/// <summary>
		/// m[g̎ށB
		/// </summary>
		public enum NoteType : ushort {
			/// <summary>
			/// `B͎gpȂB
			/// </summary>
			Nothing = 0,
			/// <summary>
			/// ʏm[g
			/// </summary>
			Normal,
			/// <summary>
			/// Bm[g
			/// </summary>
			Hidden,
			/// <summary>
			/// Om[g̊Jn
			/// </summary>
			LongStart,
			/// <summary>
			/// Om[g̏I[
			/// </summary>
			LongEnd,
			/// <summary>
			/// n
			/// </summary>
			Mine,
		}

		/// <summary>
		/// zu郌[B
		/// </summary>
		public enum LaneType : ushort {
			Undefined,
			P1_1 = 0x01,
			P1_2,
			P1_3,
			P1_4,
			P1_5,
			P1_Sc,
			P1_Fp,
			P1_6,
			P1_7,

			P2_1 = 0x11,
			P2_2,
			P2_3,
			P2_4,
			P2_5,
			P2_Sc,
			P2_Fp,
			P2_6,
			P2_7,

			PMS_SP_1 = P1_1,
			PMS_SP_2 = P1_2,
			PMS_SP_3 = P1_3,
			PMS_SP_4 = P1_4,
			PMS_SP_5 = P1_5,
			PMS_SP_6 = P2_2,
			PMS_SP_7 = P2_3,
			PMS_SP_8 = P2_4,
			PMS_SP_9 = P2_5,


			PMS_DP_L1 = P1_1,
			PMS_DP_L2 = P1_2,
			PMS_DP_L3 = P1_3,
			PMS_DP_L4 = P1_4,
			PMS_DP_L5 = P1_5,
			PMS_DP_L6 = P1_Sc,
			PMS_DP_L7 = P1_Fp,
			PMS_DP_L8 = P1_6,
			PMS_DP_L9 = P1_7,

			PMS_DP_R1 = P2_1,
			PMS_DP_R2 = P2_2,
			PMS_DP_R3 = P2_3,
			PMS_DP_R4 = P2_4,
			PMS_DP_R5 = P2_5,
			PMS_DP_R6 = P2_Sc,
			PMS_DP_R7 = P2_Fp,
			PMS_DP_R8 = P2_6,
			PMS_DP_R9 = P2_7,

			OCT_1 = P1_1,
			OCT_2 = P1_2,
			OCT_3 = P1_3,
			OCT_4 = P1_4,
			OCT_5 = P1_5,
			OCT_6 = P1_6,
			OCT_7 = P1_7,
			OCT_8 = P2_2,
			OCT_9 = P2_3,
			OCT_10 = P2_4,
			OCT_11 = P2_5,
			OCT_12 = P2_6,
			OCT_13 = P2_7,
			OCT_LSc = P1_Sc,
			OCT_RSc = P2_Sc,
			OCT_Fp = P2_1,


		}

		/// <summary>
		/// m[g̃^CvB
		/// </summary>
		public NoteType Type;
		/// <summary>
		/// zu[B
		/// </summary>
		public LaneType Lane;
		/// <summary>
		/// WAVEԍ
		/// </summary>
		public int Wav;

		public NoteEvent(NoteType type, LaneType lane, int wav) {
			Type = type;
			Lane = lane;
			Wav = wav;
		}

		public override string ToString() {
			return string.Format("{0}, {1}, {2}", Type, (int)Lane, Wav);
		}
	}
	/// <summary>
	/// BGA\Cxg̏B
	/// </summary>
	public class BgaEvent {
		public enum EventType : int {
			/// <summary>
			/// `B͎gpȂB
			/// </summary>
			Nothing = 0,
			/// <summary>
			/// ԉ̉摜B
			/// </summary>
			Normal,
			/// <summary>
			/// ߂̃C[B
			/// </summary>
			Layer1,
			/// <summary>
			/// ߂̃C[(ŏ)
			/// </summary>
			Layer2,
			/// <summary>
			/// ~XBGAB
			/// </summary>
			Miss,
		}

		public enum ActionType : int {
			Nothing = 0,

			Change,

			Alpha,

			Argb,
		}

		public EventType Type;
		public ActionType Action;
		public int Val;

		public BgaEvent(EventType type, int val) : this(type, ActionType.Change, val) { }

		public BgaEvent(EventType type, ActionType action, int val) {
			Type = type;
			Action = action;
			Val = val;
		}

		public override string ToString() {
			return string.Format("{0}, {1}", Type, Val);
		}
	}
	/// <summary>
	/// ʂɊւCxg̏B
	/// </summary>
	public class ScoreEvent {
		public enum EventType : int {
			/// <summary>
			/// `B͎gpȂB
			/// </summary>
			Nothing = 0,
			/// <summary>
			/// ߐ̔BValue͏߂̒(b)B
			/// </summary>
			BarLine,
			/// <summary>
			/// BPM̕ύXBValueBPMB
			/// </summary>
			ChangeBpm,
			/// <summary>
			/// ʂ̒~BValue͒~(b)B
			/// </summary>
			Stop,
			/// <summary>
			/// ʂ̍ĊJBValue͎gpȂB
			/// </summary>
			Resume,
		}

		public EventType Type;
		public double Val;

		public ScoreEvent(EventType type, double val) {
			Type = type;
			Val = val;
		}

		public override string ToString() {
			return string.Format("{0}, {1}", Type, Val);
		}
	}

	public class SoundEvent {
		public int Id;

		public SoundEvent(int id) {
			Id = id;
		}

		public override string ToString() {
			return Id.ToString();
		}
	}

	/// <summary>
	/// ̑̃Cxg̏
	/// </summary>
	public class CustomEvent {
		/// <summary>
		/// zuĂ`lB
		/// </summary>
		int channel;

		public int Channel {
			get { return channel; }
		}

		/// <summary>
		/// zuĂf[^B^C~OLq̏ꍇ36ilAłȂꍇ͋Lq̒ʂ̕B
		/// </summary>
		int data;

		public int Data {
			get { return data; }
		}

		public CustomEvent(int ch, int data) {
			this.channel = ch;
			this.data = data;
		}

		public override string ToString() {
			return string.Format("{0}, {1}", channel, data);
		}
	}

	public class EventList<T> : List<Event<T>> {
		public Event<T> Add(double time, double pos, T data) {
			Event<T> ret = new Event<T>(time, pos, data);

			this.Add(ret);
			return ret;
		}

		public List<Event<T>> GetRange(double startTime, double endTime) {
			return this.FindAll(delegate(Event<T> e) { return startTime <= e.Time && e.Time < endTime; });
		}

		public Event<T> GetEventAt(double time) {
			return this.Find(delegate(Event<T> e) { return time <= e.Time; });
		}

		public Event<T> GetEventAt(double time, double span) {
			return this.Find(delegate(Event<T> e) { return time <= e.Time && e.Time < time + span; });
		}
	}

}
