using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;

namespace BmxCs {

	/// <summary>
	/// ȉt̍ۂ̎n^C~Oe[u\NXB
	/// </summary>
	public class BmxTimingTable {

		protected EventList<NoteEvent> notes;

		/// <summary>
		/// m[cɊ֘ACxg
		/// </summary>
		public EventList<NoteEvent> Notes {
			get { return notes; }
		}

		protected EventList<SoundEvent> sounds;

		/// <summary>
		/// obNOEhɊւCxg
		/// </summary>
		public EventList<SoundEvent> Sounds {
			get { return sounds; }
		}

		protected EventList<BgaEvent> bga;

		/// <summary>
		/// BGA\Ɋ֘ACxg
		/// </summary>
		public EventList<BgaEvent> Bga {
			get { return bga; }
		}

		protected EventList<ScoreEvent> score;

		/// <summary>
		/// ʏԂɊւCxg
		/// </summary>
		public EventList<ScoreEvent> Score {
			get { return score; }
		}

		/// <summary>
		/// ̑g`lɊւCxg
		/// </summary>
		protected EventList<CustomEvent> others;

		public EventList<CustomEvent> Others {
			get { return others; }
		}

		protected double timeLength;

		/// <summary>
		/// ̕ʂ̑Ŝ̒(b)
		/// </summary>
		public double TimeLength {
			get { return timeLength; }
		}

		protected double scoreLength;

		/// <summary>
		/// ̕ʂ́Aʏł̒(4/4q̈ꏬ߂PƂΒl)
		/// </summary>
		public double ScoreLength {
			get { return scoreLength; }
		}

		/// <summary>
		/// ǂݍ񂾃t@CAV BmxTimingTable CX^X쐬B
		/// </summary>
		/// <param name="bmx">e[u𐶐 Bmx f[^</param>
		public BmxTimingTable(Bmx bmx) : this(bmx, GetCustomChannels()) { }

		/// <summary>
		/// ǂݍ񂾃t@CAV BmxTimingTable CX^X쐬B
		/// </summary>
		/// <param name="bmx">e[u𐶐 Bmx f[^</param>
		/// <param name="customChannels">g`lƂĎgp`l̃XgԂ IEnumerable&lt;int&gt; </param>
		public BmxTimingTable(Bmx bmx, IEnumerable<int> customChannels) {
			sounds = new EventList<SoundEvent>();
			notes = new EventList<NoteEvent>();
			bga = new EventList<BgaEvent>();
			score = new EventList<ScoreEvent>();
			others = new EventList<CustomEvent>();

			BmxHeader h = bmx.Header;
			BmxScore s = bmx.Score;

			// ܂Aߒ擾B

			int barCount = 0;
			for (int i = 0; i < 0xFF; i++) {
				int tmp = (s[i] == null ? 0 : s[i].Size);
				if (tmp > barCount)
					barCount = tmp;
			}

			double barStartSec;	// ߃[vɂȀ߂̊Jn
			double barStartPos; // ߃[vɂȀ߂̊ył̈ʒu
			double basicBpm;	// ݂̏߂̊{BPM

			// BPM擾B
			if (!double.TryParse(h["BPM"], out basicBpm))
				basicBpm = 130;

			// bB
			barStartSec = 0.0;
			// ʒuB
			barStartPos = 0.0;

			//
			// Ԃ
			//

			// BPMւ̕ύX
			score.Add(-1, 0, new ScoreEvent(ScoreEvent.EventType.ChangeBpm, basicBpm));
			// ~XBGAύX
			bga.Add(-1, 0, new BgaEvent(BgaEvent.EventType.Miss, 0));

			// BPMύXɁAʏ`Ɗg`̂ǂ炪gpĂ邩Bg`DB
			int bpmEventCh = 3;
			if (s[8].Size != 0)
				bpmEventCh = 8;

			// Om[g쐬̂߂́Ae[ł̍Ō̃m[g
			Event<NoteEvent>[] lastnote_1p = new Event<NoteEvent>[9];
			Event<NoteEvent>[] lastnote_2p = new Event<NoteEvent>[9];
			Event<NoteEvent>[] lastln_1p = new Event<NoteEvent>[9];
			Event<NoteEvent>[] lastln_2p = new Event<NoteEvent>[9];

			// LNOBJ̊mF
			int LnObjId;
			{
				string tmp = h["LNOBJ"];
				LnObjId = (tmp == null ? -1 : Base36.ToInt(tmp));
			}


			// ꏬ߂ǂݎĔzuĂƁB
			for (int barIndex = 0; barIndex < barCount; barIndex++) {

				/**
				** 
				** ܂AXRAɊւf[^m肳B 
				**
				**/

				// ̏߂̒擾B`ĂȂꍇ͒Ȍ߂̒gpB
				double barSize = 1.0;
				if (s[2][barIndex] != null && s[2][barIndex].DivisionNum != 0)
					barSize = s[2][barIndex][0][0];

				// ̏ߒłBPMύX^C~O(b)
				double[] bpmChangeSec = null;
				// ̊e^C~OɂBPM
				double[] bpmChange = null;

				// ̏߂̒(b)
				double barSizeSec = 0.0;

				// BPMύXoA^C~OɂBPM擾B
				if (s[bpmEventCh][barIndex] != null && s[bpmEventCh][barIndex].DivisionNum != 0) {
					BmxScore.BarEvent chbpm = s[bpmEventCh][barIndex];

					int div = chbpm.DivisionNum;
					bpmChange = new double[div];
					bpmChangeSec = new double[div];

					if (bpmEventCh == 3) {
						// ʏ`̎
						for (int i = 0; i < div; i++) {
							//bpmChange[i] = chbpm[i][0];
							if (chbpm[i].Count != 0)
								bpmChange[i] = chbpm[i][0];

							if (bpmChange[i] == 0.0) {
								if (i == 0)
									bpmChange[i] = basicBpm;
								else
									bpmChange[i] = bpmChange[i - 1];
							}
						}
					}
					else {
						// g`̎

						for (int i = 0; i < div; i++) {
							if (chbpm[i].Count == 0) {
								bpmChange[i] = basicBpm;
								continue;
							}

							double tmp;
							if (!double.TryParse(h.GetBPM((int)chbpm[i][0]), out tmp))
								tmp = 0.0;
							
							bpmChange[i] = tmp;

							if (bpmChange[i] == 0.0) {
								if (i == 0)
									bpmChange[i] = basicBpm;
								else
									bpmChange[i] = bpmChange[i - 1];
							}
						}
					}
				}
				else {
					// BPMύXƂ
					bpmChange = new double[1];
					bpmChangeSec = new double[1];
					bpmChange[0] = basicBpm;
				}

				// BPMAe^C~Oł̎Ԃ擾
				bpmChangeSec[0] = 0.0;



				{
					double sec = 0.0;
					for (int i = 0; i < bpmChange.Length; i++) {
						double tmp = CalcUnitSec(bpmChange[i], barSize, bpmChange.Length);
						bpmChangeSec[i] = sec;
						if (basicBpm != bpmChange[i]) {
							// BPM̕ύXAScoreXgɒǉ
							score.Add(barStartSec + bpmChangeSec[i], barStartPos + i * barSize / bpmChange.Length, new ScoreEvent(ScoreEvent.EventType.ChangeBpm, bpmChange[i]));
							basicBpm = bpmChange[i];
						}

						sec += tmp;
					}

					barSizeSec = sec;
				}


				// mB


				/**
				** 
				** ɁÃf[^ɊeCxg̔^C~OvZB
				**
				**/

				//	ׂXg
				//	obNOEh
				//	m[c
				//		ʏm[g1`5,Sc,Fp,6,7 / 1P,2P
				//			LnObjꍇɂ́A𗘗păOm[g𐶐(obNgbN)
				//		Bm[g
				//		Om[g
				//		n
				//	摜
				//		ʏ
				//		C[1,2
				//		~X
				//	̑Aȃ`l

				// \ɂȂ肻Ȃ̂ŁA֐Đ؂蔲ׂB

				#region obNOEh
				{
					BmxScore.Channel ch = s[0x01];
					if (ch.Size != 0)
						ProceedEvent(ch[barIndex], barSize, bpmChange,
							delegate(double _sec, double _pos, float _data) {
								sounds.Add(barStartSec + _sec, barStartPos + _pos, new SoundEvent((int)_data));
							});

				}
				#endregion

				#region 1p ʏm[g
				for (int i = 0; i < 9; i++) {
					BmxScore.Channel ch = s[0x11 + i];
					if (ch.Size == 0) continue;
					ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							if (_data == (float)LnObjId && lastnote_1p[i] != null && lastnote_1p[i].Data.Type == NoteEvent.NoteType.Normal) {
								lastnote_1p[i].Data.Type = NoteEvent.NoteType.LongStart;
								lastnote_1p[i] = notes.Add(barStartSec + _sec, barStartPos + _pos, new NoteEvent(NoteEvent.NoteType.LongEnd, (NoteEvent.LaneType)((int)NoteEvent.LaneType.P1_1 + i), (int)_data));
								return;
							}

							lastnote_1p[i] = notes.Add(barStartSec + _sec, barStartPos + _pos, new NoteEvent(NoteEvent.NoteType.Normal, (NoteEvent.LaneType)((int)NoteEvent.LaneType.P1_1 + i), (int)_data));
						});

				}
				#endregion

				#region 2p ʏm[g
				for (int i = 0; i < 9; i++) {
					BmxScore.Channel ch = s[0x21 + i];
					if (ch.Size == 0) continue;
					ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							if (_data == (float)LnObjId && lastnote_2p[i] != null && lastnote_2p[i].Data.Type == NoteEvent.NoteType.Normal) {
								lastnote_2p[i].Data.Type = NoteEvent.NoteType.LongStart;
								lastnote_2p[i] = notes.Add(barStartSec + _sec, barStartPos + _pos, new NoteEvent(NoteEvent.NoteType.LongEnd, (NoteEvent.LaneType)((int)NoteEvent.LaneType.P2_1 + i), (int)_data));
								return;
							}

							lastnote_2p[i] = notes.Add(barStartSec + _sec, barStartPos + _pos, new NoteEvent(NoteEvent.NoteType.Normal, (NoteEvent.LaneType)((int)NoteEvent.LaneType.P2_1 + i), (int)_data));
						});
				}
				#endregion

				#region 1p Bm[g
				for (int i = 0; i < 9; i++) {
					BmxScore.Channel ch = s[0x31 + i];
					if (ch.Size == 0) continue;
					ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							notes.Add(barStartSec + _sec, barStartPos + _pos, new NoteEvent(NoteEvent.NoteType.Hidden, (NoteEvent.LaneType)((int)NoteEvent.LaneType.P1_1 + i), (int)_data));
						});
				}
				#endregion

				#region 2p Bm[g
				for (int i = 0; i < 9; i++) {
					BmxScore.Channel ch = s[0x41 + i];
					if (ch.Size == 0) continue;
					ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							notes.Add(barStartSec + _sec, barStartPos + _pos, new NoteEvent(NoteEvent.NoteType.Hidden, (NoteEvent.LaneType)((int)NoteEvent.LaneType.P2_1 + i), (int)_data));
						});
				}
				#endregion

				#region 1p Om[g
				for (int i = 0; i < 9; i++) {
					BmxScore.Channel ch = s[0x51 + i];
					if (ch.Size == 0) continue;
					ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							if (lastln_1p[i] == null || lastln_1p[i].Data.Type == NoteEvent.NoteType.LongEnd)
								lastln_1p[i] = notes.Add(barStartSec + _sec, barStartPos + _pos, new NoteEvent(NoteEvent.NoteType.LongStart, (NoteEvent.LaneType)((int)NoteEvent.LaneType.P1_1 + i), (int)_data));
							else
								lastln_1p[i] = notes.Add(barStartSec + _sec, barStartPos + _pos, new NoteEvent(NoteEvent.NoteType.LongEnd, (NoteEvent.LaneType)((int)NoteEvent.LaneType.P1_1 + i), (int)_data));
						});
				}
				#endregion

				#region 2p Om[g
				for (int i = 0; i < 9; i++) {
					BmxScore.Channel ch = s[0x61 + i];
					if (ch.Size == 0) continue;
					ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							if (lastln_2p[i] == null || lastln_2p[i].Data.Type == NoteEvent.NoteType.LongEnd)
								lastln_2p[i] = notes.Add(barStartSec + _sec, barStartPos + _pos, new NoteEvent(NoteEvent.NoteType.LongStart, (NoteEvent.LaneType)((int)NoteEvent.LaneType.P2_1 + i), (int)_data));
							else
								lastln_2p[i] = notes.Add(barStartSec + _sec, barStartPos + _pos, new NoteEvent(NoteEvent.NoteType.LongEnd, (NoteEvent.LaneType)((int)NoteEvent.LaneType.P2_1 + i), (int)_data));
						});
				}
				#endregion

				#region 1p n
				for (int i = 0; i < 9; i++) {
					BmxScore.Channel ch = s[0xD1 + i];
					if (ch.Size == 0) continue;
					ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							notes.Add(barStartSec + _sec, barStartPos + _pos, new NoteEvent(NoteEvent.NoteType.Mine, (NoteEvent.LaneType)((int)NoteEvent.LaneType.P1_1 + i), (int)_data));
						});
				}
				#endregion

				#region 2p n
				for (int i = 0; i < 9; i++) {
					BmxScore.Channel ch = s[0xE1 + i];
					if (ch.Size == 0) continue;
					ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							notes.Add(barStartSec + _sec, barStartPos + _pos, new NoteEvent(NoteEvent.NoteType.Mine, (NoteEvent.LaneType)((int)NoteEvent.LaneType.P2_1 + i), (int)_data));
						});
				}
				#endregion

				#region BGA layer0
				{
					BmxScore.Channel ch = s[0x04];
					if (ch.Size != 0) {
						ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							bga.Add(barStartSec + _sec, barStartPos + _pos, new BgaEvent(BgaEvent.EventType.Normal, (int)_data));
						});
					}
				}
				#endregion

				#region BGA layer1
				{
					BmxScore.Channel ch = s[0x07];
					if (ch.Size != 0) {
						ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							bga.Add(barStartSec + _sec, barStartPos + _pos, new BgaEvent(BgaEvent.EventType.Layer1, (int)_data));
						});
					}
				}
				#endregion

				#region BGA layer2
				{
					BmxScore.Channel ch = s[0x0A];
					if (ch.Size != 0) {
						ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							bga.Add(barStartSec + _sec, barStartPos + _pos, new BgaEvent(BgaEvent.EventType.Layer2, (int)_data));
						});
					}
				}
				#endregion

				#region BGA Miss
				{
					BmxScore.Channel ch = s[0x06];
					if (ch.Size != 0) {
						ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							bga.Add(barStartSec + _sec, barStartPos + _pos, new BgaEvent(BgaEvent.EventType.Miss, (int)_data));
						});
					}
				}
				#endregion

				#region BGA layer0-2/miss Alpha
				for (int i = 0; i < 4; i++) {
					BmxScore.Channel ch = s[0x0A + i];
					if (ch.Size != 0) {
						ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							bga.Add(barStartSec + _sec, barStartPos + _pos, new BgaEvent((BgaEvent.EventType)((int)BgaEvent.EventType.Normal + i), (int)_data));
						});
					}
				}
				#endregion

				#region BGA layer0-2/miss ARGB
				for (int i = 0; i < 4; i++) {
					BmxScore.Channel ch = s[0x0A + i];
					if (ch.Size != 0) {
						ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							string[] param = (h.GetDefinition("ARGB", (int)_data) ?? "").Split(',');

							if (param.Length < 4)
								param = new string[] { "255", "255", "255", "255" };

							int _val = 0;
							for (int k = 0; k < 4; k++)
								_val = (_val << 8) + int.Parse(param[k]);

							bga.Add(barStartSec + _sec, barStartPos + _pos, new BgaEvent((BgaEvent.EventType)((int)BgaEvent.EventType.Normal + i), _val));
						});
					}
				}
				#endregion

				#region Cxg
				foreach (int chid in customChannels) {
					BmxScore.Channel ch = s[chid];
					if (ch.Size == 0) continue;
					ProceedEvent(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data) {
							others.Add(barStartSec + _sec, barStartPos + _pos, new CustomEvent(chid, (int)_data));
						});

				}
				#endregion



				/**
				** 
				** YꂽɃXgbvV[PXo^A^Ce[uɎB
				**
				**/
				notes.Sort();
				sounds.Sort();
				bga.Sort();
				score.Sort();
				others.Sort();

				#region StopSequence
				{
					BmxScore.Channel ch = s[0x09];
					if (ch.Size != 0) {
						ProceedEventWithBPM(ch[barIndex], barSize, bpmChange,
						delegate(double _sec, double _pos, float _data, double _bpm) {
							double time = double.Parse(h.GetSTOP((int)_data)) * CalcUnitSec(_bpm, 1.0, 192);

							{
								List<Event<ScoreEvent>> _sc = score.GetRange(barStartSec + _sec, double.PositiveInfinity);
								foreach (Event<ScoreEvent> e in _sc) {
									if (e.Time != _sec)
										e.Time += time;
								}
							}

							{
							
								List<Event<BgaEvent>> _bga = bga.GetRange(barStartSec + _sec, double.PositiveInfinity);
								foreach (Event<BgaEvent> e in _bga) {
									if (e.Time != _sec)
										e.Time += time;
								}
							}

							{
								List<Event<SoundEvent>> _so = sounds.GetRange(barStartSec + _sec, double.PositiveInfinity);
								foreach (Event<SoundEvent> e in _so) {
									if (e.Time != _sec)
										e.Time += time;
								}
							}

							{
								List<Event<NoteEvent>> _nt = notes.GetRange(barStartSec + _sec, double.PositiveInfinity);
								foreach (Event<NoteEvent> e in _nt) {
									if (e.Time != _sec)
										e.Time += time;
								}
							}

							{
								List<Event<CustomEvent>> _ot = others.GetRange(barStartSec + _sec, double.PositiveInfinity);
								foreach (Event<CustomEvent> e in _ot) {
									if (e.Time != _sec)
										e.Time += time;
								}
							}

							score.Add(barStartSec + _sec, barStartPos + _pos, new ScoreEvent(ScoreEvent.EventType.Stop, time));
							score.Add(barStartSec + _sec + time, barStartPos + _pos, new ScoreEvent(ScoreEvent.EventType.Resume, 0));

							barSizeSec += time;
						});

					}
				}
				#endregion

				// ߂̒m肵̂ŁAߐ̃Cxgǉ
				score.Add(barStartSec, barStartPos, new ScoreEvent(ScoreEvent.EventType.BarLine, barSizeSec));
				

				// Ԃi߂āȀ߂ցB
				barStartSec += barSizeSec;
				barStartPos += barSize;

			}
			// ꏬ߂ǂݎĔzuĂƂ̃[vI[B

			notes.Sort();
			sounds.Sort();
			bga.Sort();
			score.Sort();
			others.Sort();

			timeLength = barStartSec;
			scoreLength = barStartPos;
		}

		/// <summary>
		/// BarEventf[^AeCxg̔ԂvZAw肳ꂽnhĂԃ\bh
		/// </summary>
		/// <param name="be">ΏۂBarEvent</param>
		/// <param name="barlen">̏߂̃TCY</param>
		/// <param name="bpmChange">̏߂ɂBPMύX̃f[^</param>
		/// <param name="addAction">Ƀe[uւ̒ǉƂsnh</param>
		protected static void ProceedEvent(BmxScore.BarEvent be, double barlen, double[] bpmChange, AddAction addAction) {
			if (be == null) return;

			int bpmLen = bpmChange.Length;
			int eventLen = be.DivisionNum;
			int mulLen = bpmLen * eventLen;

			double eventSec = 0.0;
			int bpmIndex = 0;
			double stepSec = 0;
			for (int timing = 0; timing < eventLen; timing++) {

				// ̃^C~ÕCxgɊ蓖ĂbvZAeventSecɓB

				int di = 0;

				//	while ((bpmIndex + 1) / bpmLen < i / eventLen) {
				while ((bpmIndex + 1) * eventLen < timing * bpmLen) {
					// BPMύX(ȏ)܂

					// ύXOBPMŌo߂(ڍׂ)Zo
					int w = (bpmIndex + 1) * eventLen - (di + timing * bpmLen);

					stepSec += CalcUnitSec(bpmChange[bpmIndex], barlen, mulLen) * w;

					// dii߂
					di += w;

					bpmIndex++;
				}

				// BPMύX͂܂Ȃ

				double diff = CalcUnitSec(bpmChange[bpmIndex], barlen, mulLen) * (bpmLen - di);
				stepSec += diff;



				IList<float> li = be[timing];
				if (li == null) 
					continue;
				
				foreach (float f in li) {
					//    // ŒǉĂ
					//    sounds.Add(eventSec, i * barlen / li.Count, (int)f);
					addAction(eventSec, (timing * barlen) / eventLen, f);
				}

				eventSec += stepSec;
				stepSec = 0;
			}
		}

		/// <summary>
		/// BarEventf[^AeCxg̔ԂvZAw肳ꂽnhĂԃ\bhB
		/// ̂ƂBPMɒʒmB
		/// </summary>
		/// <param name="be">ΏۂBarEvent</param>
		/// <param name="barlen">̏߂̃TCY</param>
		/// <param name="bpmChange">̏߂ɂBPMύX̃f[^</param>
		/// <param name="addAction">Ƀe[uւ̒ǉƂsnh</param>
		protected static void ProceedEventWithBPM(BmxScore.BarEvent be, double barlen, double[] bpmChange, AddActionEx addAction) {
			if (be == null) return;

			int bpmLen = bpmChange.Length;
			int eventLen = be.DivisionNum;
			int mulLen = bpmLen * eventLen;

			double eventSec = 0.0;
			int bpmIndex = 0;
			double stepSec = 0;
			for (int timing = 0; timing < eventLen; timing++) {

				// ̃^C~ÕCxgɊ蓖ĂbvZAeventSecɓB

				int di = 0;

				//	while ((bpmIndex + 1) / bpmLen < i / eventLen) {
				while ((bpmIndex + 1) * eventLen < timing * bpmLen) {
					// BPMύX(ȏ)܂

					// ύXOBPMŌo߂(ڍׂ)Zo
					int w = (bpmIndex + 1) * eventLen - (di + timing * bpmLen);

					stepSec += CalcUnitSec(bpmChange[bpmIndex], barlen, mulLen) * w;

					// dii߂
					di += w;

					bpmIndex++;
				}

				// BPMύX͂܂Ȃ

				double diff = CalcUnitSec(bpmChange[bpmIndex], barlen, mulLen) * (bpmLen - di);
				stepSec += diff;



				IList<float> li = be[timing];
				if (li == null)
					continue;

				foreach (float f in li) {
					//    // ŒǉĂ
					//    sounds.Add(eventSec, i * barlen / li.Count, (int)f);
					addAction(eventSec, (timing * barlen) / eventLen, f, bpmChange[bpmIndex]);
				}

				eventSec += stepSec;
				stepSec = 0;
			}
		}


		/// <summary>
		/// BPMƏߕAꕪ̕bZo
		/// </summary>
		/// <param name="bpm">BPM</param>
		/// <param name="barlen">ߒ 4/4߂1.0ƂΒl</param>
		/// <param name="division">ߕ</param>
		/// <returns></returns>
		protected static double CalcUnitSec(double bpm, double barlen, int division) {
			double ret = 240.0 / bpm * barlen / division;
			return ret;
		}

		protected delegate void AddAction(double sec, double pos, float data);
		protected delegate void AddActionEx(double sec, double pos, float data, double bpm);



		protected static int[] CustomChannels = {0x99, 0xA0, 0xA5 };

		protected static IEnumerable<int> GetCustomChannels() {
			foreach (int chid in CustomChannels)
				yield return chid;
		}

		// 牺͂ƂŎ܂

		public delegate void ProceedActionEventHandler(object sender, ProceedActionEventArgs e);

		public class ProceedActionEventArgs : EventArgs {
			double sec;
			double pos;
			float data;
			int barDivision;
			int barTiming;
			double bpm;
			double barSize;
			int barIndex;

			public double Sec {
				get { return sec; }
			}

			public double Position {
				get { return pos; }
			}

			public float Data {
				get { return data; }
			}

			public int BarDivision {
				get { return barDivision; }
			}

			public int BarTiming {
				get { return barTiming; }
			}

			public int BarIndex {
				get { return barIndex; }
			}

			public double Bpm {
				get { return bpm; }
			}

			public double BarSize {
				get { return barSize; }
			}

			public ProceedActionEventArgs(double _sec, double _pos, float _data, double _bpm, 
				int _baridx, int _bardiv, int _bartiming, double _barsize) {

				this.barDivision = _bardiv;
				this.barIndex = _baridx;
				this.barSize = _barsize;
				this.barTiming = _bartiming;
				this.bpm = _bpm;
				this.data = _data;
				this.pos = _pos;
				this.sec = _sec;
			}
		}

	}

}
