using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using BmxCs;

namespace bmxCsTest {
	public partial class Form1 : Form {
		public Form1() {
			InitializeComponent();
		}

		Bmx bmx;

		private void Form1_Load(object sender, EventArgs e) {
			//bmx = BmxLoader.Load(@"D:\temp\[sasakureUK]Pangaea\02_pangaea[7MAIN].bme");
			//bmx = BmxLoader.Load(@"D:\temp\X\X.bme");
			//bmx = BmxLoader.Load(@"D:\temp\[ni~YLEVeB]RE\NRvCAX\11_kousoku_comp[7KEYS].bml");
			//bmx = BmxLoader.Load(@"D:\temp\53\yamajet-time_is_money-24.bme");
			bmx = OpenBmx();

			if (bmx == null) {
				MessageBox.Show("Lȃt@Cw肳܂łBI܂B");
				this.Close();
				return;
			}

			foreach(KeyValuePair<string, string> v in bmx.Header.GetDictionary())
				listBox1.Items.Add(v);


			//GC.Collect();

			this.Text = "wb_ƃCxg (Pattern = ";
			foreach (int i in bmx.Pattern)
				this.Text += i.ToString() + ", ";
			if (this.Text.EndsWith(", ")) {
				this.Text = this.Text.TrimEnd(',', ' ');
			}
			else {
				this.Text += "Ȃ";
			}
			this.Text += ")";

			BmxTimingTable table = bmx.CreateTimingTable();
			new Form2(table).Show();
			new Form3(table).Show();
		}

		private Bmx OpenBmx() {
			openFileDialog1.CheckFileExists = true;
			openFileDialog1.Filter = "Bms/Bme/Bml/Pms File|*.bms;*.bme;*.bml;*.pms";

			if (openFileDialog1.ShowDialog() == DialogResult.OK)
				return BmxLoader.Load(openFileDialog1.FileName);
			else
				return null;
		}

		private void numericUpDown1_ValueChanged(object sender, EventArgs e) {
			listBox2.Items.Clear();

			int chid = (int)numericUpDown1.Value;
			BmxScore.Channel ch = bmx.Score[chid];

			for (int i = 0; i < ch.Size; i++) {
				BmxScore.BarEvent ev = ch[i];

				if (ev == null) {
					listBox2.Items.Add(string.Format("#{0} empty", i));
				}
				else {

					listBox2.Items.Add(string.Format("#{0} ({1})", i, ev.DivisionNum));


					for (int j = 0; j < ev.DivisionNum; j++) {
						IList<float> l = ev[j];
						StringBuilder sb = new StringBuilder();

						if (l != null) {
							foreach (float f in l) {
								if (sb.Length != 0)
									sb.Append(", ");

								if (chid == 2)
									sb.Append(f);
								else
									sb.Append(Base36.ToBase36((int)f));
							}
						}
						
						listBox2.Items.Add(string.Format("  {0}", sb.ToString()));
					}
				}
			}
			
		}
	}
}