using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using BmxCs;

namespace bmxCsTest {
	public partial class Form2 : Form {
		BmxTimingTable timings;
		public Form2(BmxTimingTable table) {
			InitializeComponent();
			timings = table;
		}

		private void Form2_Load(object sender, EventArgs e) {
			comboBox1.SelectedIndex = 0;
		}

		private void comboBox1_SelectedIndexChanged(object sender, EventArgs e) {
			
			switch (comboBox1.SelectedIndex) {
				case 0: // score
					ListupHelper<ScoreEvent>.ListUp(timings.Score, listBox1);
					break;
				case 1: // notes
					ListupHelper<NoteEvent>.ListUp(timings.Notes, listBox1);
					break;
				case 2: // sounds
					ListupHelper<SoundEvent>.ListUp(timings.Sounds, listBox1);
					break;
				case 3: // bgas
					ListupHelper<BgaEvent>.ListUp(timings.Bga, listBox1);
					break;
				case 4: // other
					ListupHelper<CustomEvent>.ListUp(timings.Others, listBox1);
					break;
			}
		}

		static class ListupHelper<T> {
			public static void ListUp(EventList<T> list, ListBox target) {
				target.Items.Clear();
				foreach (Event<T> item in list) 
					target.Items.Add(item);
				
			}
		}
	}
}